<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Item extends Model
{
    protected $casts = [ 'id' => 'integer' ];

    public function category()
    {
        return $this->belongsTo('App\ItemType', 'sale_unit');
    }

    public function images()
    {
        return $this->hasMany('App\ItemImage');
    }

//    public function shop()
//    {
//        //return $this->belongsTo('App\Badrshop','shop_id','serial_id');
//    }
    /*
        public function getImgAttribute($img)
        {
            if ($img == "")
            {
                return "images/img.jpg";
            }
            $url = str_replace('https:/www.badrforsales.com/online/','',$img);
            $url = str_replace('https://www.badrforsales.com/online/','',$img);
            $url = str_replace('https://badrforsales.com/online/','',$img);
            return $url;
        }

        public function getSalePriceAttribute($price)
        {
            if (count($this->shop) > 0)
            {
                return number_format($price,$this->shop->decimal_num_price);
            }
            return number_format($price,2);
        }


    */

    public function getImg($shop_id)
    {
//        $logo = config('app.base_url') . \DB::table('badr_shop')
//                ->where('serial_id', $shop_id)
//                ->first()->logo_path;
        $logo = config('app.badrshop_url') . "images/img.jpg";

        if (in_array($this->img, ['', null])) {
            return $logo;
        } else {
            /* if (file_exists('admin/' . $this->img)) {

                 return config('app.badrshop_url') . $this->img;
             } elseif (file_exists('admin/upload/' . $this->img)) {
           */
            if (strpos( $this->img, 'c-admin/upload/') !== false) {
                return config('app.base_url') . $this->img;
            }
            return config('app.base_url') . 'c-admin/upload/' . $this->img;
            /*   } else {
                   return $logo;
               }*/
        }
    }

    public function getCards($bill_id)
    {
        $cards_query = Card::where([
            'shop_id' => $this->shop_id,
            'item_id' => $this->id,
            'sale_id' => $bill_id,
            'card_state' => 1
        ])->pluck('card_number');
        $data = [];
        $cards_enc = json_decode(json_encode($cards_query));
        if (sizeof($cards_enc) > 0) {
            foreach ($cards_query as $item) {
                $data[] = $this->decrypt($item);
            }
        }
        return $data;
    }

    private function decrypt($encrypted)
    {
        $password = '3sc3RLrpd1LBVFTsdFVaadjsdXFS';
        $method = 'aes-256-cbc';
        $key = substr(hash('sha256', $password, true), 0, 512);

        $iv = chr(0x0) . chr(0x0) . chr(0x0) . chr(0x0) . chr(0x0) . chr(0x0) . chr(0x0) . chr(0x0) . chr(0x0) . chr(0x0) . chr(0x0) . chr(0x0) . chr(0x0) . chr(0x0) . chr(0x0) . chr(0x0);

        $decrypted = openssl_decrypt(base64_decode($encrypted), $method, $key, OPENSSL_RAW_DATA, $iv);

        $data = explode('--', $decrypted);
        $decrypt = $data[1];
        return $decrypt;
    }

}
