<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Foundation\Auth\User as Authenticatable;
class Client extends Authenticatable
{
    protected $table = 'clients';
    protected $hidden = ['password'];
    public $timestamps = true;
   // protected $fillable = array('client_name','user_name', 'password', 'rememberToken', 'api_token', 'tele');
    protected $fillable = ['client_name',  'tele','mobile1', 'balance','shop_id',
        'remember_token', 'password', 'user_name', 'player_id',
        'verified_mobile', 'device_key', 'active_code', 'api_token' ,'app_client_id'];

    public function appClient()
    {
        return $this->belongsTo('App\AppClient');
    }


    public function generateToken()
    {
        $this->api_token = str_random(60);
        $this->save();
        return $this->api_token;
    }

    public function tokens()
    {
        return $this->morphMany('App\Token', 'accountable');
    }

    public function requests()
    {
        return $this->hasMany('App\CartRequest');
    }

    public function channel()
    {
        return $this->hasMany('App\Channel', 'client_id', 'id');
    }

    public function point()
    {
        return $this->hasOne('App\ClientPoint', 'client_id');
    }


    public function getImage($shop_id)
    {
        $logo = config('app.badrshop_url') . \DB::table('badr_shop')
                ->where('serial_id', $shop_id)
                ->first()->logo_path;

        // dd($logo);
        if (in_array($this->image, ['', null])) {
            return $logo;
        } else {
            /* if (file_exists('admin/' . $this->img)) {

                 return config('app.badrshop_url') . $this->img;
             } elseif (file_exists('admin/upload/' . $this->img)) {
           */
            if (strpos( $this->image, 'upload/client/') !== false) {
                return config('app.badrshop_url') . $this->image;
            }
            return config('app.badrshop_url') . 'upload/client/' . $this->image;

            /*   } else {
                   return $logo;
               }*/
        }
    }
}
