<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Coupon extends Model
{
    protected $fillable = [];
    public $timestamps = false;
    protected $table = 'request_coupons';

    public function getStatus()
    {
        if($this->is_valid == 1){
            return 'مفعل';
        }else{
            return 'غير مفعل';
        }
    }

    public function getDiscountType()
    {
        if($this->discount_type == 0){
            $type = '%';
        }else{
            $currency = \DB::table('badr_shop')->first()->currency;
            $type = $currency;
        }
        return $type;
    }

    public function getStand()
    {

        if($this->is_valid == 1 && strtotime(date('Y-m-d')) == strtotime($this->expire_date)){
            return '<p class="text-warning">ينتهي اليوم</p>';
        }


        if($this->is_valid == 0 && strtotime(date('Y-m-d')) == strtotime($this->expire_date)){
            return '<p class="text-warning">غير مفعل وينتهي اليوم</p>';
        }



        if(strtotime(date('Y-m-d')) < strtotime($this->expire_date)){
            if($this->is_valid == 1){
                return '<p class="text-success">متاح</p>';
            }else{
                return '<p class="text-danger"> غير مفعل</p>';
            }
        }else{
            return '<p class="text-danger">  منتهي الصلاحية</p>';
        }

    }

    public function check()
    {
        if($this->is_valid == 1 && strtotime(date('Y-m-d')) <= strtotime($this->expire_date)){
            return true;
        }else{
            return false;
        }

    }

    public function getStandString()
    {

        if($this->is_valid == 1 && strtotime(date('Y-m-d')) == strtotime($this->expire_date)){
            if ($this->use_for == 1)
                return 'هذا الكوبون للاستخدام مرة واحدة فقط';
            else
                return 'ينتهي اليوم';
        }


        if($this->is_valid == 0 && strtotime(date('Y-m-d')) == strtotime($this->expire_date)){
            return 'غير مفعل وينتهي اليوم';
        }



        if(strtotime(date('Y-m-d')) < strtotime($this->expire_date)){
            if($this->is_valid == 1){
                if ($this->use_for == 1)
                    return 'هذا الكوبون للاستخدام مرة واحدة فقط';
                else
                    return 'متاح';
            }else{
                return ' غير مفعل';
            }
        }else{
            return ' منتهي الصلاحية';
        }

    }

    /**
     * Check what the coupon can be used for
     *
     * 0 => Many Times
     * 1 => One Time
     * 2 => Fee Discount
     * @return boolean
     */
    public function checkCouponUse($order_id)
    {
        $c = $this;
        if ($this->check()) {
            if ($this->use_for == 1) {
                if (auth('client')->user()) {
                    $check = \DB::table('requests')
                        ->where(function($q) use ($c){
                            $q->where('coupon_id', $c->id)
                            ->where('coupon_id','>', 0);
                        })
                        ->where('client_id', auth('client')->id());
                        
                        if($order_id > 0){
                            $check = $check->where('id', '!=', $order_id);
                        }
                      
                         $check = $check->first();
                    return ($check) ? false : true;
                } else {
                    return 'unAuthorized';
                }
            } else if ($this->use_for == 2) {
                return 'feeDiscount';
            } else {
                return true;
            }
        } else {
            return false;
        }
    }
}
