<?php

namespace App\Http\Controllers\ApiV2;

use App\City;
use App\Unit;
use App\Item;
use App\BillAdd;
use App\Badrshop;
use App\Favorite;
use App\ItemSize;
use App\ItemUnit;
use App\ItemColor;
use App\Http\Requests;
use App\RequestDetails;
use App\RequestSettings;
use Illuminate\Pagination\LengthAwarePaginator;
use Illuminate\Pagination\Paginator;
use Illuminate\Http\Request;
use App\ShippingDistancesPrice;
use App\Http\Controllers\Controller;

class BasicController extends Controller
{
    public function getItemsDataCollection($items, $shop_id, $order_id=0)
    {
        $items = $items->keyBy('id');
        foreach ($items as $k => $ci) {
            $ci = $this->getItemData($ci, $shop_id, null, $order_id);
            if($ci == false){
                $items->forget($k);
            }
        }
        
        // try {
        //     $items = $items->filter(function ($item) {
        //         if (in_array($item->online, [2, '2']))
        //             return $item->quantity > 0;
        //         else
        //             return true;
        //     })->unique('id')->values();
        // } catch (\Throwable $th) {
            $items = $items->values();
        // }
        
        // $items = $this->paginate($items , 10);
        
        return $items;
    }
    public function paginate($items, $perPage)
    {
        $pageStart = request('page', 1);
        $offSet = ($pageStart * $perPage) - $perPage;
        $itemsForCurrentPage = $items->slice($offSet, $perPage);

        return new LengthAwarePaginator(
            $itemsForCurrentPage, $items->count(), $perPage,
            Paginator::resolveCurrentPage(),
            ['path' => Paginator::resolveCurrentPath()]
        );
    }
    
    public function getItemDataTemp($ci, $shop_id, $units_ids=null, $order_id=0, $return_false=true)
    {


        if (auth()->guard('client')->user()) {
            $fav = Favorite::where('client_id', auth()->guard('client')->user()->id)->where('product_id', $ci->id)->first();
            if ($fav) {
                $ci->fav = true;
            } else {
                $ci->fav = false;
            }
        } else {
            $ci->fav = false;
        }
        $ci->unit = Unit::where('id', $ci->unit_id)->first()->name;
        $ci->img = $ci->getImg($shop_id);


        $settings = $this->getOrderSettings($shop_id);
        $max_count = $settings->max_items ?? 0; //20
        $item_id = $ci->id;

        $item = Item::find($item_id);

        if (!in_array($ci->card_company_id, ['', '0', null])) {
            $max_count = $settings->max_cards;
            $card_count = $this->cardCount($ci);

            if ($card_count < $max_count) {
                $max_count = $card_count;
            }
        } else {
            if ($settings->dis_req_quantity == 1) {

                $getRequests = \DB::table('request_details')
                    ->join('requests', function ($q) use ($item) {
                        $q->on('request_details.request_id', '=', 'requests.id')
                            ->where('request_details.item_id', '=', $item->id);
                    })
                    ->leftJoin('items_unit', function ($query) {
                        $query->on(function ($q) {
                            $q->on('items_unit.id', '=', 'request_details.unit_id')
                                ->orOn('items_unit.unit_id', '=', 'request_details.unit_id');
                        })->on('items_unit.item_id', '=', 'request_details.item_id');
                    })
                    ->where('requests.no_bill', null)
                    ->whereNotIn('requests.status', ['0'])
                    ->selectRaw('request_details.id,quantity as main_quantity,SUM(IF(items_unit.id > 0,items_unit.unit_value * quantity,quantity))AS quantity')
                    ->first();

                $main_quantity = $getRequests->main_quantity;
                $getRequests = $getRequests->quantity;
            } else {
                $getRequests = 0;
            }


            $newQty = $ci->quantity - $getRequests;
    
            $max_count = $newQty;
            
            if ($newQty <= 0) {
                $max_count = 0;
            }

            /*
            if ($newQty < $max_count && $newQty > 0) {
                $max_count = $newQty;
            }
            */
            
            // if ($ci->quantity < $max_count) {
            //     $max_count = $ci->quantity;
            // }
        }
        
    

        $ci->quantity = (float)$max_count;

        // if ($ci->online == 2)
        //     if ($ci->quantity <= 0 && $return_false)
        //         return false;

        $ci_units = [];
        $units_arr = [];
        if ($order_id > 0) {
            // \DB::enableQueryLog();
            $units = collect(\DB::table('request_details')
                ->join('items', 'items.id', '=', 'request_details.item_id')
                ->where('request_details.request_id', $order_id)
                ->where('request_details.item_id', $ci->id)
                ->select('request_details.unit_id')
                ->get())->pluck('unit_id');
            $ci_units = ItemUnit::where('shop_id', $shop_id)->where('item_id', $ci->id)->whereIn('unit_id', $units)->get();

            if ($units->contains($ci->unit_id))
                $units_arr = array([
                    'unit_id' => $ci->unit_id,
                    'price' => $ci->sale_price,
                    'unit_value' => (float)1,
                    'quantity' => (float)$max_count,
                    'max_qty' => $ci->max_qty ?? 0,
                    'main_quantity' => floor($main_quantity ?? 0),
                ]);
        } else {
            $ci_units = ItemUnit::where('shop_id', $shop_id)->where('item_id', $ci->id)->get();
            $units_arr = array([
                'unit_id' => $ci->unit_id,
                'price' => $ci->sale_price,
                'unit_value' => (float)1,
                'quantity' => (float)$max_count,
                'max_qty' => $ci->max_qty ?? 0,
                'main_quantity' => floor($main_quantity ?? 0),
            ]);
        }

        foreach ($ci_units as $unit) {

            $main_quantity = RequestDetails::leftJoin('items_unit', function ($q) {
                    $q->on('items_unit.id', '=', 'request_details.unit_id');
                    $q->on('items_unit.item_id', '=', 'request_details.item_id');
                })
                ->where('request_id', $order_id)
                ->where('request_details.item_id', $unit->item_id)
                ->where('request_details.unit_id', $unit->unit_id)
                ->selectRaw(' if( items_unit.id > 0, items_unit.unit_value * quantity ,quantity ) as quantity')
                ->first()->quantity ?? 0;

            $n_qty = (float)($newQty / (float)$unit->unit_value);

            if ($n_qty < $max_count) {
                $max_count = $n_qty;
            }
            $max_count = floor($max_count);

            $new_arr = array([
                'unit_id' => $unit->unit_id,
                'price' => $unit->unit_price,
                'unit_value' => (float)$unit->unit_value,
                'quantity' => $max_count,
                'max_qty' => $unit->max_qty ?? 0,
                'main_quantity' => floor($main_quantity ?? 0),
            ]);
            $units_arr = array_merge($units_arr, $new_arr);
        }

        $vs_query_ = \DB::table('bills_add')
            ->where('shop_id', $shop_id);
        $vs = $vs_query_->get();

        $new_arr_units = [];

        foreach ($units_arr as $unit) {

            //            dd(var_dump($new_arr_units));
            $basic_price = $unit['price'];

            $sale_price = $basic_price;
            $dis = 0.00;
            if ($ci->withDiscount == 0) {
                $new_price = $sale_price;
                $unit['sale_price'] = price_decimal($sale_price, $shop_id);
                $unit['new_price'] = price_decimal($sale_price, $shop_id);
            } else {
                $unit['sale_price'] = price_decimal($sale_price, $shop_id);
                $new_price = $sale_price - $this->calcItemDiscount($settings, $ci, $sale_price);
                $unit['new_price'] = price_decimal($new_price, $shop_id);
                $basic_price = price_decimal($new_price, $shop_id);

                $dis = $this->getItemDiscount($settings, $ci);
            }

            $vat = 0.00;


            if ($ci->vat_state == 2) {
                $v_ = $vs_query_->where('id', $ci->vat_id)->first();
                if ($v_) {
                    $unit['vat_name'] = $v_->Addition_name;
                    $basic_price = $unit['new_price'] / (1 + ($v_->addition_value / 100));
                } else {

                    $unit['vat_name'] = "";
                }
            } else {
                $unit['vat_name'] = "";
            }

            if ($ci->vat_state != '0') {
                foreach ($vs as $vc) {
                    $type = $vc->check_addition;
                    $val = $vc->addition_value;
                    if ($type) {
                        $vat += $val;
                    } else {
                        $vat += $basic_price * $val / 100;
                    }
                }
            }

            //                    $sale_price = $ci->sale_price;
            $currency = Badrshop::select('currency')->where('serial_id', $shop_id)->first()->currency;
            $unit['discount'] = price_decimal($dis, $shop_id) . ' ' . ($settings->discount_type == 'percent' ? '%' : $currency);
            $unit['basic_price'] = price_decimal($basic_price, $shop_id);
            $unit['vat'] = price_decimal($vat, $shop_id);

            $unit['unit_name'] = Unit::where('shop_id', $shop_id)->where('id', $unit['unit_id'])->first()->name ?? "";


            $unit['qty_problem'] = $unit['quantity'] > 0 ? false : true;

            array_push($new_arr_units, $unit);
        }

        $sub_cat = \DB::table('items_type')
            ->whereId($ci->sale_unit)
            ->first();


        if ($sub_cat) {

            $ci->sub_cat = $sub_cat->name;

            $main_cat = \DB::table('items_type')
                ->whereId($sub_cat->category_id)
                ->first();
            if ($main_cat) {
                $ci->main_cat = $main_cat->name;
            } else {
                $ci->main_cat = '--';
            }
        } else {
            $ci->sub_cat = '--';
        }

        $size = ItemSize::where('id', $ci->color_id)->first();
        if ($size) {
            $ci->size = $size->size_name;
        } else {
            $ci->size = '--';
        }

        $color = ItemColor::where('id', $ci->color_id)->first();
        if ($color) {
            $ci->color = $size->color_name;
        } else {
            $ci->color = '--';
        }








        $isCard = $this->cardCheck($ci);
        //        $im_fee = 0.00;
        //        if ($isCard == '0') {
        //            $im_fee = $settings->fee;
        //            if ($settings->fee_type == '0') {
        //                $im_fee = $im_fee / 100 * ($new_price - $dis);
        //            }
        //        }

        //        $ci->fee = price_decimal($im_fee, $shop_id);

        $ci->qty_problem = $ci->quantity > 0 ? false : true;

        if ($units_ids) // for items/prices request
            return array_filter($new_arr_units, function ($item) use ($units_ids) {
                return in_array($item['unit_id'], $units_ids);
            });

        $ci->new_arr_units = $new_arr_units;
        return $ci;
    }
    
    public function getItemData($ci, $shop_id, $units_ids=null, $order_id=0, $return_false=true)
    {


        if (auth()->guard('client')->user()) {
            $fav = Favorite::where('client_id', auth()->guard('client')->user()->id)->where('product_id', $ci->id)->first();
            if ($fav) {
                $ci->fav = true;
            } else {
                $ci->fav = false;
            }
        } else {
            $ci->fav = false;
        }
        $ci->unit = Unit::where('id', $ci->unit_id)->first()->name;
        $ci->img = $ci->getImg($shop_id);


        $settings = $this->getOrderSettings($shop_id);
        $max_count = $settings->max_items ?? 0; //20
        $item_id = $ci->id;

        $item = Item::find($item_id);

        if (!in_array($ci->card_company_id, ['', '0', null])) {
            $max_count = $settings->max_cards;
            $card_count = $this->cardCount($ci);

            if ($card_count < $max_count) {
                $max_count = $card_count;
            }
        } else {
            if ($settings->dis_req_quantity == 1) {

                $getRequests = \DB::table('request_details')
                    ->join('requests', function ($q) use ($item) {
                        $q->on('request_details.request_id', '=', 'requests.id')
                            ->where('request_details.item_id', '=', $item->id);
                    })
                    ->leftJoin('items_unit', function ($query) {
                        $query->on(function ($q) {
                            $q->on('items_unit.id', '=', 'request_details.unit_id')
                                ->orOn('items_unit.unit_id', '=', 'request_details.unit_id');
                        })->on('items_unit.item_id', '=', 'request_details.item_id');
                    })
                    ->where('requests.no_bill', null)
                    ->whereNotIn('requests.status', ['0'])
                    ->selectRaw('request_details.id,quantity as main_quantity,SUM(IF(items_unit.id > 0,items_unit.unit_value * quantity,quantity))AS quantity')
                    ->first();

                $main_quantity = $getRequests->main_quantity;
                $getRequests = $getRequests->quantity;
            } else {
                $getRequests = 0;
            }


            $newQty = $ci->quantity - $getRequests;
    
            $max_count = $newQty;
            
            if ($newQty <= 0) {
                $max_count = 0;
            }

            /*
            if ($newQty < $max_count && $newQty > 0) {
                $max_count = $newQty;
            }
            */
            
            // if ($ci->quantity < $max_count) {
            //     $max_count = $ci->quantity;
            // }
        }
        
    

        $ci->quantity = (float)$max_count;

        // if ($ci->online == 2)
        //     if ($ci->quantity <= 0 && $return_false)
        //         return false;

        $ci_units = [];
        $units_arr = [];
        $ci->max_qty = is_null($ci->max_qty) || $ci->max_qty == 0 || $ci->max_qty > $max_count ? $max_count : $ci->max_qty;
        if ($order_id > 0) {
            // \DB::enableQueryLog();
            $details = \DB::table('request_details')
                ->join('items', 'items.id', '=', 'request_details.item_id')
                ->where('request_details.request_id', $order_id)
                ->where('request_details.item_id', $ci->id)
                ->select(['request_details.unit_id', 'request_details.quantity'])
                ->get();
            // dd($details);
            $units = collect($details)->pluck('unit_id');
            $ci_units = ItemUnit::where('shop_id', $shop_id)->where('item_id', $ci->id)->whereIn('unit_id', $units)->get();

            if ($units->contains($ci->unit_id)) {
                $units_arr = array([
                    'unit_id' => $ci->unit_id,
                    'price' => $ci->sale_price,
                    'unit_value' => (float)1,
                    'quantity' => (float)$max_count + collect($details)->where('unit_id', $ci->unit_id)->first()->quantity,
                    'max_qty' => $ci->max_qty ?? 0,
                    'main_quantity' => floor($main_quantity ?? 0),
                ]);
            } else {
                $units_arr = array([
                    'unit_id' => $ci->unit_id,
                    'price' => $ci->sale_price,
                    'unit_value' => (float)1,
                    'quantity' => (float)$max_count,
                    'max_qty' => $ci->max_qty ?? 0,
                    'main_quantity' => floor($main_quantity ?? 0),
                ]);
            }
        } else {
            $ci_units = ItemUnit::where('shop_id', $shop_id)->where('item_id', $ci->id)->get();
            $units_arr = array([
                'unit_id' => $ci->unit_id,
                'price' => $ci->sale_price,
                'unit_value' => (float)1,
                'quantity' => (float)$max_count,
                'max_qty' => $ci->max_qty ?? 0,
                'main_quantity' => floor($main_quantity ?? 0),
            ]);
        }

        foreach ($ci_units as $unit) {

            $main_quantity = RequestDetails::leftJoin('items_unit', function ($q) {
                    $q->on('items_unit.id', '=', 'request_details.unit_id');
                    $q->on('items_unit.item_id', '=', 'request_details.item_id');
                })
                ->where('request_id', $order_id)
                ->where('request_details.item_id', $unit->item_id)
                ->where('request_details.unit_id', $unit->unit_id)
                ->selectRaw(' if( items_unit.id > 0, items_unit.unit_value * quantity ,quantity ) as quantity')
                ->first()->quantity ?? 0;

            $n_qty = (float)($newQty / (float)$unit->unit_value);

            if ($n_qty < $max_count) {
                $max_count = $n_qty;
            }
            $max_count = floor($max_count);

            $new_arr = array([
                'unit_id' => $unit->unit_id,
                'price' => $unit->unit_price,
                'unit_value' => (float)$unit->unit_value,
                'quantity' => $max_count + $main_quantity,
                'max_qty' => $unit->max_qty ?? 0,
                'main_quantity' => floor($main_quantity ?? 0),
            ]);
            $units_arr = array_merge($units_arr, $new_arr);
        }

        $vs_query_ = \DB::table('bills_add')
            ->where('shop_id', $shop_id);
        $vs = $vs_query_->get();

        $new_arr_units = [];

        foreach ($units_arr as $unit) {

            //            dd(var_dump($new_arr_units));
            $basic_price = $unit['price'];

            $sale_price = $basic_price;
            $dis = 0.00;
            if ($ci->withDiscount == 0) {
                $new_price = $sale_price;
                $unit['sale_price'] = price_decimal($sale_price, $shop_id);
                $unit['new_price'] = price_decimal($sale_price, $shop_id);
            } else {
                $unit['sale_price'] = price_decimal($sale_price, $shop_id);
                $new_price = $sale_price - $this->calcItemDiscount($settings, $ci, $sale_price);
                $unit['new_price'] = price_decimal($new_price, $shop_id);
                $basic_price = price_decimal($new_price, $shop_id);

                $dis = $this->getItemDiscount($settings, $ci);
            }

            $vat = 0.00;


            if ($ci->vat_state == 2) {
                $v_ = $vs_query_->where('id', $ci->vat_id)->first();
                if ($v_) {
                    $unit['vat_name'] = $v_->Addition_name;
                    $basic_price = $unit['new_price'] / (1 + ($v_->addition_value / 100));
                } else {

                    $unit['vat_name'] = "";
                }
            } else {
                $unit['vat_name'] = "";
            }

            if ($ci->vat_state != '0') {
                foreach ($vs as $vc) {
                    $type = $vc->check_addition;
                    $val = $vc->addition_value;
                    if ($type) {
                        $vat += $val;
                    } else {
                        $vat += $basic_price * $val / 100;
                    }
                }
            }

            //                    $sale_price = $ci->sale_price;
            $currency = Badrshop::select('currency')->where('serial_id', $shop_id)->first()->currency;
            $unit['discount'] = price_decimal($dis, $shop_id) . ' ' . ($settings->discount_type == 'percent' ? '%' : $currency);
            $unit['basic_price'] = price_decimal($basic_price, $shop_id);
            $unit['vat'] = price_decimal($vat, $shop_id);

            $unit['unit_name'] = Unit::where('shop_id', $shop_id)->where('id', $unit['unit_id'])->first()->name ?? "";


            $unit['qty_problem'] = $unit['quantity'] > 0 ? false : true;

            array_push($new_arr_units, $unit);
        }

        $sub_cat = \DB::table('items_type')
            ->whereId($ci->sale_unit)
            ->first();


        if ($sub_cat) {

            $ci->sub_cat = $sub_cat->name;

            $main_cat = \DB::table('items_type')
                ->whereId($sub_cat->category_id)
                ->first();
            if ($main_cat) {
                $ci->main_cat = $main_cat->name;
            } else {
                $ci->main_cat = '--';
            }
        } else {
            $ci->sub_cat = '--';
        }

        $size = ItemSize::where('id', $ci->color_id)->first();
        if ($size) {
            $ci->size = $size->size_name;
        } else {
            $ci->size = '--';
        }

        $color = ItemColor::where('id', $ci->color_id)->first();
        if ($color) {
            $ci->color = $size->color_name;
        } else {
            $ci->color = '--';
        }








        $isCard = $this->cardCheck($ci);
        //        $im_fee = 0.00;
        //        if ($isCard == '0') {
        //            $im_fee = $settings->fee;
        //            if ($settings->fee_type == '0') {
        //                $im_fee = $im_fee / 100 * ($new_price - $dis);
        //            }
        //        }

        //        $ci->fee = price_decimal($im_fee, $shop_id);

        $ci->qty_problem = $ci->quantity > 0 ? false : true;

        if ($units_ids) // for items/prices request
            return array_filter($new_arr_units, function ($item) use ($units_ids) {
                return in_array($item['unit_id'], $units_ids);
            });

        $ci->new_arr_units = $new_arr_units;
        return $ci;
    }

    private function getOrderSettings($shop_id)
    {

        $settings = RequestSettings::where('shop_id', $shop_id)->first();
        if (is_null($settings)) {
            $settings = new RequestSettings();
            $settings->fee = 0;
            $settings->min_purchase = 0;
            $settings->max_charge = 0;
            $settings->max_cards = 5;
            $settings->max_items = 20;
            $settings->shop_id = $shop_id;
            $settings->discount_type = 'percent';
            $settings->save();
        }

        return $settings;
    }
    private function cardCheck($item)
    {
        $cardCompany_id = $item->card_company_id;
        if (in_array($cardCompany_id, ['0', '', null])) {
            return '0';
        }
        return $cardCompany_id;
    }


    public function CalcFee($request, $net)
    {
        $setting = RequestSettings::where('shop_id', $request->shop_id)->first();
       
        if ($setting->fee_type == 3) {
            $lat = $request->lat;
            $lon = $request->lon;
            $original_lat = $setting->lat;
            $original_lon = $setting->lon;
            $theta = $lon - $original_lon;
            $dist = sin(deg2rad($lat)) * sin(deg2rad($original_lat)) + cos(deg2rad($lat)) * cos(deg2rad($original_lat)) * cos(deg2rad($theta));
            $dist = acos($dist);
            $dist = rad2deg($dist);
            $miles = $dist * 60 * 1.1515;
            $distance = $miles * 1.609344;
            $price = ShippingDistancesPrice::where('shop_id', $request->shop_id)->whereRaw(" $distance  BETWEEN km_from AND km_to")->first();
            if ($price) {
                $fee = price_decimal($distance * $price->price_per_kilo, $request->shop_id);
            } else {
                $fee = 0;
            }
        } elseif ($setting->fee_type == 0) {
            $fee = price_decimal(($net * $setting->fee / 100), $request->shop_id);
        } elseif ($setting->fee_type == 2) {
            $city_id = $request->city_id;
            $city = City::where('shop_id', $request->shop_id)->where('id', $city_id)->first();


            if ($city) {
                $fee = $city->fee;
            } else {
                $fee = 0;
            }
        } else {
            $fee = $setting->fee;
        }
        return $fee;
    }

    public function calcItemDiscount($settings, $item, $sale_price) {
        if ($settings->discount_type == 'percent')
            return ($sale_price * $item->discount_percent / 100);
        else
            return ($item->discount_percent);
    }

    public function getItemDiscount($settings, $item) {
        if ($settings->discount_type == 'percent')
            return $item->discount_percent;
        else
            return $item->discount_percent;
    }

    public function getItemsNeededCols() {
        return [
            'items.id',
            'items.item_name',
            'items.sale_price',
            'items.sale_unit',
            'items.img',
            'items.unit_id',
            'items.size_id',
            'items.color_id',
            'items.about',
            'items.withDiscount',
            'items.discount_percent',
            'items.discount_quantity',
            'items.discount_percent AS discount_amount',
            'items.details',
            'items.card_company_id',
            'items.size_id',
            'items.color_id',
            'items.quantity',
            'items.vat_id',
            'items.vat_state',
            'items.shop_id',
            'items.max_qty',
            'items.online'
        ];
    }
}
