<?php

namespace App\Http\Controllers\ApiV2;

use App\User;
use Validator;
use App\Client;

use App\Badrshop;
use App\CartRequest;
use App\Http\Requests;
use App\RequestSettings;
use App\Ibnfarouk\Helper;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class ClientsController extends Controller
{
    public function __construct()
    {
        $this->middleware('auth:client')
            ->except('create', 'authenticate', 'test', 'sendCode', 'resetClientPassword');
    }


    public function sendCode(Request $request)
    {
        $email = $request->email;
        $shop_id = $request->shop_id;

        try {
            $client = Client::where('email', $email)->where('shop_id', $shop_id)->first();
            
          
            $client->active_code = mt_rand(100000, 999999);
            $client->save();
       
            $data = [
                'name' => $client->client_name,
                'code' => $client->active_code,
            ];
            
            
            $shop = Badrshop::where('serial_id',$shop_id)->first();

           $x=  \Mail::send('password', ['data' => $data], function ($m) use ($client ,$shop) {
                $m->from('info@badrsystems.com', $shop->shop_name);
                $m->to($client->email, $client->client_name)->subject('Forget Password!');
            });
        
        // return $x;
        
            return response()->json([
                'status' => true,
                'msg' => 'تم ارسال كود استرجاع كلمة المرور الي بريدك الالكتروني'

            ]);

        } catch (\Exception $e) {

            return response()->json([
                'status' => false,
                'msg' => 'يرجي التأكد من البريد الالكتروني وأعد المحاولة'
            ]);
        }
    }

    public function resetClientPassword(Request $request)
    {
        $phone = $request->email;
        $shop_id = $request->shop_id;
        $code = $request->code;
        $password = $request->password;

        $messages = [
            'email.required' => " حقل البريد الالكتروني مطلوب ",
            'code.required' => " حقل الكود مطلوب ",
            'password.required' => " حقل كلمه المرور مطلوب ",
            'password.confirmed' => "كلمه المرور غير متطابقه "
        ];


        $validator = Validator::make($request->all(), [
            'email' => 'required',
            'code' => 'required',
            'password' => 'required|confirmed',
        ], $messages);


        if ($validator->fails()) {

            $errors = $validator->errors();
            $error_data = [];
            foreach ($errors->all() as $error) {
                array_push($error_data, $error);
            }
            $data = $error_data;


            $response = [
                'error' => $data,
                // 'msg' => 'من فضلك أدخل جميع الحقول وتأكد من صحة رقم الهاتف',
                'status' => false
            ];

            return response()->json($response);
        }

        $client = Client::where('email', $phone)->where('shop_id', $shop_id)->first();


        if ($client) { //=> if Client in DB.
            //return $client;
            if ($client->active_code == $code) { //=>if Client in DB but if $code confirmaet with code that in D.B ;

                $client->password = md5($password);
                $client->save();

                return response()->json([
                    'status' => true,
                    'msg' => 'تم تعديل كلمه المرور الخاصه بك  '
                ]);

            }
            return response()->json([
                'status' => false,
                'msg' => 'رقم الكود الذي ادخلته غير متطابق'

            ]);
        } else {

            return response()->json([
                'status' => false,
                'msg' => 'البريد الالكتروني غير صحيح'

            ]);
        }


    }


    public function create(Request $request)
    {
        // \Log::info(json_encode($request->all()));
        // dd('test');
        $rules = [
            // 'client_name' => 'required',
            'tele' => 'required|unique:clients,tele,NULL,id,shop_id,'.$request->shop_id,
            'user_name' => 'required',
            'device_key' => 'required',
            'password' => 'required',
            'shop_id' => 'required',
            'email' => 'required|email|unique:clients,email,NULL,id,shop_id,'.$request->shop_id,
            'player_id' => 'required',
            'city_id' => 'required',
            'shop_name'=>'required',
            'lat'=>'required',
            'lon'=>'required',
            "address2" =>'required',
            "address" =>'required',
        ];


        $msgs = [
            // 'client_name.required' => 'الاسم مطلوب',
            'email.required' => 'البريد الالكتروني مطلوب',
            'tele.required' => 'صيغة الهاتف المطلوبة ',
            'tele.unique' => 'الجوال مستخدم من قبل ',
            'email.unique' => 'البريد الالكتروني مستخدم من قبل ',
            'email.email' => 'صيغة البريد الالكتروني غير صحيحة',
            'password.required' => 'كلمة المرور مطلوبة',
            'player_id.required' => 'player_id required',
            'shop_name.required' =>'اسم المحل مطلوب',
            'lat.required' => 'العنوان مطلوب',
            'lon.required' => 'العنوان مطلوب',
            'city_id.required' => ' المدينة مطلوبة',
            "address2.required" =>"العنوان مطلوب",
            "address2" =>"العنوان مطلوب",
            "address.required" =>"العنوان مطلوب",
        ];


        $validator = Validator::make($request->all(), $rules, $msgs);


        if ($validator->fails()) {
            $errors = $validator->errors();
            $error_data = [];
            foreach ($errors->all() as $error) {
                array_push($error_data, $error);
            }
            $data = $error_data;


            $response = [
                'error' => $data,
                // 'msg' => 'من فضلك أدخل جميع الحقول وتأكد من صحة رقم الهاتف',
                'status' => false
            ];

            return response()->json($response);
        }

        $client = new Client();
        $client->client_name = $request->shop_name;
        $client->shop_name = $request->client_name;
        $client->address =$request->address;
        $client->address2 =$request->address2;
        $client->tele = $request->tele;
        $client->email = $request->email;
        $client->city_id = $request->city_id ?? 0;
        $client->balance = 0;
        $client->user_name = $request->user_name;
        $client->password = md5($request->password);
        $client->city_id = $request->city_id ?? 0;
         $client->lat =$request->lat;
        $client->lon =$request->lon;
        $client->shop_id = $request->shop_id;
        $client->device_key = $request->device_key;
        $client->player_id = $request->player_id;
        $client->active_code = mt_rand(100000, 999999);
        $client->verified_mobile = 1;
        $client->generateToken();
        if ($client->save()) {
            $client->signin = [
                "href" => "api/v1/client/login",
                "method" => "POST",
                "params" => "tele, password, shop_id"
            ];

            $response = [
                "msg" => "تم تسجيل الحساب بنجاح",
                "token" => $client->api_token,
                "client_id" => $client->id,
                "email" => $client->email,
                "phone" => $client->tele,
                "client_name" => $this->checkLastClientId($client->id) ? $client->shop_name : $client->client_name,
                "shop_name"=> $this->checkLastClientId($client->id) ? $client->client_name : $client->shop_name,
                "mobile1" => $client->mobile1 ?? '',
                "active_code" => $client->active_code,
                "activated" => $client->verified_mobile,
                "balance" => $client->balance,
                "status" => true,
                    "lat" =>$client->lat,
                    "lon" =>$client->lon,
                    "address" =>$client->address,
                    "address2" =>$client->address2,
                    "city_id"=>$client->city_id,
            ];
            return response()->json($response, 201);
        }
        $response = [
            'msg' => 'عذراً! حدث خط أثناء عملية التسجيل',
            'status' => false
        ];
        return response()->json($response, 200);


    }

    public function authenticate(Request $request)
    {
        $setting = RequestSettings::where('shop_id', $request->shop_id)->first();
        \Log::info("shop_id: {$request->shop_id}, env-type: " . $request->header('env-type'));
        $messages = [
            'password.required' => "كلمه المرور مطلوب"
        ];
        if ($setting->login == 0) {
            $messages['tele.required'] = "البريد الالكتروني او رقم الهاتف مطلوب";
        } elseif ($setting->login == 1) {
            $messages['tele.required'] = "البريد الالكتروني مطلوب";
        } else {
           
            $messages['tele.required'] = "رقم الهاتف مطلوب";
        }

        $validator = Validator::make($request->all(), [
            'tele' => 'required',
            'password' => 'required'
        ], $messages);

        if ($validator->fails()) {
            $errors = $validator->errors();
            $error_data = [];
            foreach ($errors->all() as $error) {
                array_push($error_data, $error);
            }
            $response = [
                'status' => false,
                'error' => $error_data
            ];

            return response()->json($response);
        }

        $email = $request->tele;
        $password = md5($request->password);
        $client = Client::where(function ($q) use ($email) {
            $q->where('email', $email);
            $q->orWhere('tele', $email);
        })
            ->where('shop_id', $request->shop_id)
            ->first();

        if ($client) {
            if ($client->password === $password) {

                if ($client->api_token == null) {
                    $client->api_token = str_random(60);
                }
                $client->device_key = $request->device_key ?? $client->device_key;
                $client->player_id = $request->player_id ?? $client->player_id;
                $client->save();

                $response = [
                    "status" => true,
                    "msg"    => "تم تسجيل الدخول بنجاح",
                    "token" => $client->api_token,
                    "client_id" => $client->id,
                    "client_name" => $this->checkLastClientId($client->id) ? $client->shop_name : $client->client_name,
                    "shop_name"=>$this->checkLastClientId($client->id) ? $client->client_name : $client->shop_name,
                    "email" => $client->email,
                    "phone" => $client->tele,
                    "mobile1" => $client->mobile1 ?? '',
                    "active_code" => $client->active_code,
                    "activated" => $client->verified_mobile,
                    "balance" => $client->balance,
                    "lat" =>$client->lat,
                    "lon" =>$client->lon,
                    "address" =>$client->address,
                    "address2" =>$client->address2,
                    "city_id" =>$client->city_id,
                ];
                return response()->json($response, 200);
            } else {
                $response = [
                    "status" => false,
                    "msg" => "كلمة المرور غير صحيحة"
                ];
                return response()->json($response, 200);
            }
        }
        $response = [
            "status" => false,
            "msg" => "بيانات الدخول غير صحيحة"
        ];
        return response()->json($response, 200);
        // $password = md5($request->password);

        // $client = Client::where('email', $request->tele)
        //     ->where('shop_id', $request->shop_id)->first();

        // if ($client) {
        //     if ($client->password === $password) {

        //         if ($client->api_token == null) {
        //             $client->api_token = str_random(60);
        //         }
        //         $client->device_key = $request->device_key ?? $client->device_key;
        //         $client->player_id = $request->player_id ?? $client->player_id;
        //         $client->save();

        //         $response = [
        //             "msg" => "تم تسجيل الدخول بنجاح",
        //             "token" => $client->api_token,
        //             "client_id" => $client->id,
        //             "email" => $client->email,
        //             "phone" => $client->tele,
        //             "client_name" => $client->client_name,

        //             "active_code" => $client->active_code,
        //             "activated" => $client->verified_mobile,
        //             "balance" => $client->balance,
        //             "status" => true
        //         ];
        //         return response()->json($response, 200);
        //     } else {
        //         $response = [
        //             "msg" => "كلمة المرور غير صحيحة",
        //             "status" => false
        //         ];
        //         return response()->json($response, 200);
        //     }
        // }
        // $response = [
        //     "msg" => "البريد الالكتروني غير مسجل",
        //     "status" => false
        // ];
        // return response()->json($response, 200);
    }

    public function activeClient(Request $request)
    {
        $client = Client::where('active_code', $request->activation_code)->first();

        if (count($client)) {
            if ($client->verified_mobile == 1) {
                $response = [
                    'msg' => 'تم تفعيل العضوية مسبقاً !',
                    'client_id' => $client->id,
                    'token' => $client->api_token,
                    'activated' => $client->verified_mobile,
                    'status' => true
                ];
                return response()->json($response, 200);
            }
            $client->verified_mobile = 1;
            $client->save();
            $response = [
                'msg' => 'تم تفعيل العضوية بنجاح',
                'client_id' => $client->id,
                'token' => $client->api_token,
                'activated' => $client->verified_mobile,
                'status' => true
            ];
            return response()->json($response, 200);
        } else {
            $response = [
                'msg' => 'عفواً كود التفعيل الذي أدخلته غير صحيح !',
                'status' => false
            ];
            return response()->json($response, 200);
        }


    }

    public function getOrders()
    {
        $orders = CartRequest::with('requestDetails')->where('client_id', auth()->guard('client')->id())->get();
        if (count($orders)) {
            $response = [
                'orders' => $orders,
                'status' => true
            ];
            return response()->json($response, 200);
        }
        $response = [
            'msg' => 'لا توجد طلبات',
            'status' => false
        ];
        return response()->json($response, 200);

    }

    public function requestActivationCode(Request $request)
    {
        $client = Client::where('tele', $request->phone)->first();
        $sms = Helper::sendsms($client->tele, $client->active_code);

        $sms = json_decode($sms);
        if ($sms->ErrorCode == 000) {

            // $x = explode('-', $sms);
            // if($x[0] == '3'){

            $response = [
                "msg" => "تم إرسال رسالة لرقم الهاتف بها كود التفعيل",
                "token" => $client->api_token,
                "client_id" => $client->id,
                "activated" => $client->verified_mobile,
                "active_code" => $client->active_code,
                "status" => true
            ];
            return response()->json($response, 201);
        }
        $response = [
            'msg' => 'من فضلك تأكد من صحة رقم الهاتف الذي أدخلته',
            'status' => false
        ];
        return response()->json($response, 200);

    }


    public function test()
    {

        $sms = Helper::sendsms('0565231525', '123456');

        $sms = json_decode($sms);

        if ($sms->ErrorCode == 000) {

            dd($sms);

        } else {

            dd('121313');
        }


    }
    
    protected function getNewSlug()
    {
        $user = auth()->guard('client')->user();
        $newSlug = rand() . 'deleted-';
        if (Client::where('tele', $newSlug . $user->tele)->first()) {
            $newSlug = $this->getNewSlug();
        }
        return $newSlug;
    }


    public function deleteAccount()
    {
        $user = auth()->guard('client')->user();

        if ($user) {
            $slug = $this->getNewSlug();
            
            $user->email = $slug . $user->email;
            $user->tele = $slug . $user->tele;
            // $user->shop_id = 0;
            $user->save();

            return response()->json([
                'status' => true,
                'message' => 'Done!',
                'logout' => true
            ]);
        }

        return response()->json([
            'status' => false,
            'message' => 'Error!'
        ]);
    }

    protected function checkLastClientId(int $id)
    {
        return $id > env('LAST_CLIENT_ID', 122);
    }
}
