<?php

namespace App\Http\Controllers\ApiV2;

use App\Http\Controllers\ApiV2\BasicController;
use Illuminate\Http\Request;
use App\Item;

class ItemController extends BasicController {
    public function getPrices(Request $request, $shop_id) {
        logger(json_encode($request->all()));
        $ids = $this->getIds($request->input('items_details', []));

        $items = Item::join('units', 'items.unit_id', '=', 'units.id')
                ->whereIn('items.id', $ids['items'])
                ->where('items.shop_id', $shop_id)
                ->where('items.available', 1)
                ->whereIn('items.online', [1, 2])
                ->select($this->getItemsNeededCols())
                ->get();

        $res = [];
        foreach ($items as $index => &$ci) {
            foreach($request->input('items_details', []) as $key => $item_detail) {
                if ($item_detail['item_id'] != $ci->id) continue;
                
                if ($item = $this->getItemData($ci, $shop_id, $ids['units'][$ci->id], $request->get('order_id', 0), true)) {
                    $res[$key] = [
                        'item_id' => $ci->id,
                        'new_arr_units' => collect($item)->unique('unit_id')->values()
                    ];
                }
            }
        }
        
        ksort($res);
        return response()->json([
            'items_details' => $res,
            'status' => true
        ]);
    }

    private function getIds($items_details) {
        $items = $units = [];
        foreach ($items_details as $item_details) {
            $items[] = $item_details['item_id'];
            $units[$item_details['item_id']][] = $item_details['unit_id'];
        }
        return compact('items', 'units');
    }
}
