<?php

namespace App\Http\Controllers\ApiV5;

use App\Item;
use App\City;
use App\Unit;
use App\BillAdd;
use App\Badrshop;
use App\Favorite;
use App\ItemSize;
use App\ItemUnit;
use App\ItemColor;
use App\Http\Requests;
use App\RequestDetails;
use App\RequestSettings;
use Illuminate\Pagination\LengthAwarePaginator;
use Illuminate\Pagination\Paginator;
use Illuminate\Http\Request;
use App\ShippingDistancesPrice;
use App\Http\Controllers\Controller;

class BasicController extends Controller
{
    
    
    public function getItemsDataCollection($items, $shop_id, $order_id=0)
    {
     
        $items = $items->keyBy('id');
  
        foreach ($items as $k => $ci) {
            $ci = $this->getItemData($ci, $shop_id, $order_id);
            if($ci == false || !$ci->quantity){
               
                $items->forget($k);
            }
        }
        $items = $items->values();
        
        // $items = $this->paginate($items , 10);
        
        return $items;
    }
    
    
    public function paginate($items, $perPage)
    {
        $pageStart = request('page', 1);
        $offSet = ($pageStart * $perPage) - $perPage;
        $itemsForCurrentPage = $items->slice($offSet, $perPage);

        return new LengthAwarePaginator(
            $itemsForCurrentPage, $items->count(), $perPage,
            Paginator::resolveCurrentPage(),
            ['path' => Paginator::resolveCurrentPath()]
        );
    }
    
    public function getItemData($ci, $shop_id, $order_id=0)
    {


        if (auth()->guard('client')->user()) {
            $fav = Favorite::where('client_id', auth()->guard('client')->user()->id)->where('product_id', $ci->id)->first();
            if ($fav) {
                $ci->fav = true;
            } else {
                $ci->fav = false;
            }
        } else {
            $ci->fav = false;
        }
        $ci->unit = Unit::where('id', $ci->unit_id)->first()->name;
        $ci->img = $ci->getImg($shop_id);


        $item_id = $ci->id;
        $quantity = $ci->quantity;
        $unit_id = $ci->unit_id;

        $item = Item::find($item_id);

        if ($item->unit_id != $unit_id) {
            $unit = ItemUnit::where('shop_id', $shop_id)->where('unit_id', $unit_id)->where('item_id', $item_id)->first();
            $quantity = ($unit->unit_value ?? 1) * $quantity;
        }

        $settings = $this->getOrderSettings($shop_id);
        $max_count = $settings->max_items; //20

        if (!in_array($ci->card_company_id, ['', '0', null])) {
            $max_count = $settings->max_cards;
            $card_count = $this->cardCount($ci);

            if ($card_count < $max_count) {
                $max_count = $card_count;
            }
        } else {
            // if ($settings->dis_req_quantity == 1) {

            //     $getRequests = \DB::table('request_details')
            //         ->join('requests', function ($q) use ($item) {
            //             $q->on('request_details.request_id', '=', 'requests.id');
            //             $q->where('request_details.item_id', '=', $item->id);
            //         })
            //         ->where('requests.no_bill', null)
            //         ->whereNotIn('requests.status', ['0'])
            //         ->sum('quantity');
            // } else {
            //     $getRequests = 0;
            // }

            /*****************/
            if ($settings->dis_req_quantity == 1) {
                // $getRequests = \DB::table('request_details')
                //     ->join('requests', function ($q) use ($item) {
                //         $q->on('request_details.request_id', '=', 'requests.id');
                //         $q->where('request_details.item_id', '=', $item->id);
                //     })
                //     ->leftJoin('items_unit', function ($q) {
                //         $q->on('items_unit.id', '=', 'request_details.unit_id');
                //         $q->where('items_unit.item_id', '=', 'request_details.item_id');
                //     })
                //     ->where('requests.no_bill', null)
                //     ->whereNotIn('requests.status', ['0'])
                //     ->selectRaw('if( items_unit.id > 0,  items_unit.unit_value * quantity , quantity ) as quantity')
                //     ->sum('quantity');

                $getRequests = \DB::table('request_details')
                    ->join('requests', function ($q) use ($item) {
                        $q->on('request_details.request_id', '=', 'requests.id')
                            ->where('request_details.item_id', '=', $item->id);
                    })
                    ->leftJoin('items_unit', function ($query) {
                        $query->on(function ($q) {
                            $q->on('items_unit.id', '=', 'request_details.unit_id')
                                ->orOn('items_unit.unit_id', '=', 'request_details.unit_id');
                        })->on('items_unit.item_id', '=', 'request_details.item_id');
                    })
                    ->where('requests.no_bill', null)
                    ->whereNotIn('requests.status', ['0'])
                    ->selectRaw('request_details.id,quantity as main_quantity,SUM(IF(items_unit.id > 0,items_unit.unit_value * quantity,quantity))AS quantity')
                    ->first();
                $main_quantity = $getRequests->main_quantity;
                $getRequests = $getRequests->quantity;

                $minus_qty_from_order = 0;

                if ($order_id > 0) {

                    $detailsReduced  = RequestDetails::
                    //leftJoin('items_unit', function ($q) {
                    // $q->on('items_unit.id', '=', 'request_details.unit_id');
                    // $q->on('items_unit.item_id', '=', 'request_details.item_id');
                    // })
                    //->
                    where('request_id', $order_id)
                        ->where('request_details.item_id', $item_id)
                        ->where('request_details.unit_id', $unit_id)
                        //->selectRaw(' if( items_unit.id > 0, items_unit.unit_value * quantity ,quantity ) as quantity')
                        ->first();

                    $minus_qty_from_order = $detailsReduced->quantity ?? 0;
                }

                //  dd($getRequests, $minus_qty_from_order);

                $getRequests = $getRequests - $minus_qty_from_order;
            } else {
                $getRequests = 0;
            }

            //  dd($getRequests);
            /******************/

            //  dd($item->quantity, $getRequests);

            $newQty = $item->quantity - $getRequests;


            if ($newQty <= 0) {
                $max_count = 0;
            }

            if ($newQty < $max_count && $newQty > 0) {
                $max_count = $newQty;
            }
        }



        $ci->quantity = (float)$max_count;


//        if($max_count <= 0 && $settings->ignore_quantity == 0){
//
//            return false;
//
//        }


        $ci_units = ItemUnit::where('shop_id', $shop_id)->where('item_id', $ci->id)
        ->when($order_id > 0 && false, function ($q) use ($ci){
            return $q->where('unit_id', $ci->selected_unit);   
        })
        ->get();
        
        $units_arr = [];
        
        // dd($main_quantity);
        $units_arr = array(['unit_id' => $ci->unit_id, 'price' => $ci->sale_price, 'unit_value' => (float)1, 'quantity' => (float)$max_count, 'main_quantity' => floor($main_quantity ?? 0)]);
        foreach ($ci_units as $unit) {
            $main_quantity = RequestDetails::leftJoin('items_unit', function ($q) {
                            $q->on('items_unit.id', '=', 'request_details.unit_id');
                            $q->on('items_unit.item_id', '=', 'request_details.item_id');
                        })
                        ->where('request_id', $order_id)
                        ->where('request_details.item_id', $unit->item_id)
                        ->where('request_details.unit_id', $unit->unit_id)
                        ->selectRaw(' if( items_unit.id > 0, items_unit.unit_value * quantity ,quantity ) as quantity')
                        ->first()->quantity ?? 0;
            

            $n_qty = (float)($newQty / (float)$unit->unit_value);

            if ($n_qty < $max_count) {
                $max_count = $n_qty;
            }
            $max_count = floor($max_count);

            $new_arr = array(['unit_id' => $unit->unit_id, 'price' => $unit->unit_price, 'unit_value' => (float)$unit->unit_value, 'quantity' => $max_count, 'main_quantity' => floor($main_quantity)]);
            if($max_count > 0){
                 $units_arr = array_merge($units_arr, $new_arr);
            }
           
        }

        $vs_query_ = \DB::table('bills_add')
            ->where('shop_id', $shop_id);
        $vs = $vs_query_->get();
;
        $new_arr_units = [];

        foreach ($units_arr as $unit) {

            //            dd(var_dump($new_arr_units));
            $basic_price = $unit['price'];

            $sale_price = $basic_price;
            $dis = 0.00;
            if ($ci->withDiscount == 0) {
                $new_price = $sale_price;
                $unit['sale_price'] = price_decimal($sale_price, $shop_id);
                $unit['new_price'] = price_decimal($sale_price, $shop_id);
            } else {
                // $new_price = $sale_price;
                $percent = $ci->discount_percent;
                //                $discount = $percent * $sale_price / 100;
                $unit['sale_price'] = price_decimal($sale_price, $shop_id);
                $new_price = $sale_price - ($sale_price * $percent / 100);
                $unit['new_price'] = price_decimal($new_price, $shop_id);
                $basic_price = price_decimal($new_price, $shop_id);

                $dis = $percent;
            }

            $vat = 0.00;

            if ($ci->vat_state == 2) {
                $v_ = $vs_query_->where('id', $ci->vat_id)->first();
                if ($v_) {
                    $unit['vat_name'] = $vs->Addition_name ?? '';
                    $basic_price = $unit['new_price'] / (1 + (($v_->addition_value ?? 1) / 100));
                } else {

                    $unit['vat_name'] = "";
                }
            } else {
                $unit['vat_name'] = "";
            }

            if ($ci->vat_state != '0') {
                foreach ($vs as $vc) {
                    $type = $vc->check_addition;
                    $val = $vc->addition_value;
                    if ($type) {
                        $vat += $val;
                    } else {
                        $vat += $basic_price * $val / 100;
                    }
                }
            }

            //                    $sale_price = $ci->sale_price;
            $unit['discount'] = price_decimal($dis, $shop_id);
            $unit['basic_price'] = price_decimal($basic_price, $shop_id);
            $unit['vat'] = price_decimal($vat, $shop_id);

            $unit['unit_name'] = Unit::where('shop_id', $shop_id)->where('id', $unit['unit_id'])->first()->name ?? "";



            array_push($new_arr_units, $unit);
        }
        
        

        $sub_cat = \DB::table('items_type')
            ->whereId($ci->sale_unit)
            ->first();


        if ($sub_cat) {

            $ci->sub_cat = $sub_cat->name;

            $main_cat = \DB::table('items_type')
                ->whereId($sub_cat->category_id)
                ->first();
            if ($main_cat) {
                $ci->main_cat = $main_cat->name;
            } else {
                $ci->main_cat = '--';
            }
        } else {
            $ci->sub_cat = '--';
        }

        $size = ItemSize::where('id', $ci->color_id)->first();
        if ($size) {
            $ci->size = $size->size_name;
        } else {
            $ci->size = '--';
        }

        $color = ItemColor::where('id', $ci->color_id)->first();
        if ($color) {
            $ci->color = $size->color_name;
        } else {
            $ci->color = '--';
        }


        $isCard = $this->cardCheck($ci);
        //        $im_fee = 0.00;
        //        if ($isCard == '0') {
        //            $im_fee = $settings->fee;
        //            if ($settings->fee_type == '0') {
        //                $im_fee = $im_fee / 100 * ($new_price - $dis);
        //            }
        //        }

        //        $ci->fee = price_decimal($im_fee, $shop_id);
        $ci->new_arr_units = $new_arr_units;
        
        if(isset($ci->selected_quantity)){
            $ci->selected_quantity = (string)((int)$ci->selected_quantity);
        }
  
        return $ci;
      
    }

    private function getOrderSettings($shop_id)
    {

        $settings = RequestSettings::where('shop_id', $shop_id)->first();
        if (is_null($settings)) {
            $settings = new RequestSettings();
            $settings->fee = 0;
            $settings->min_purchase = 0;
            $settings->max_charge = 0;
            $settings->max_cards = 5;
            $settings->max_items = 20;
            $settings->shop_id = $shop_id;
            $settings->save();
        }

        return $settings;
    }
    private function cardCheck($item)
    {
        $cardCompany_id = $item->card_company_id;
        if (in_array($cardCompany_id, ['0', '', null])) {
            return '0';
        }
        return $cardCompany_id;
    }


    public function CalcFee($request, $net)
    {

        $setting = RequestSettings::where('shop_id', $request->shop_id)->first();
        if ($setting->fee_type == 3) {
            $lat = $request->lat;
            $lon = $request->lon;
            $original_lat = $setting->lat;
            $original_lon = $setting->lon;
            $theta = $lon - $original_lon;
            $dist = sin(deg2rad($lat)) * sin(deg2rad($original_lat)) + cos(deg2rad($lat)) * cos(deg2rad($original_lat)) * cos(deg2rad($theta));
            $dist = acos($dist);
            $dist = rad2deg($dist);
            $miles = $dist * 60 * 1.1515;
            $distance = $miles * 1.609344;
            $price = ShippingDistancesPrice::where('shop_id', $request->shop_id)->whereRaw(" $distance  BETWEEN km_from AND km_to")->first();
            if ($price) {
                $fee = price_decimal($distance * $price->price_per_kilo, $request->shop_id);
            } else {
                $fee = 0;
            }
        } elseif ($setting->fee_type == 0) {
            $fee = price_decimal(($net * $setting->fee / 100), $request->shop_id);
        } elseif ($setting->fee_type == 2) {
            $city_id = $request->city_id;
            $city = City::where('shop_id', $request->shop_id)->where('id', $city_id)->first();


            if ($city) {
                $fee = $city->fee;
            } else {
                $fee = 0;
            }
        } else {
            $fee = $setting->fee;
        }
        return $fee;
    }
}
