<?php

namespace App\Http\Controllers\ApiV5;

use App\ChargeCity;
use App\City;
use App\Region;
use Illuminate\Http\Request;

use App\Http\Requests;
use App\Http\Controllers\Controller;
use DB;
use Illuminate\Support\Facades\Input;

class ProvincesController extends Controller
{
    public function getAllProvinces($shop_id)
    {
        $provinces = DB::table('cities')
            ->where('city_up', 0)
            ->where('shop_id', $shop_id)
            ->get();

        if(count($provinces))
        {
            $response = [
                "provinces" => $provinces,
                "status" => true
            ];
            return response()->json($response, 200);
        } else {
            $response = [
                "msg" => "There is no provinces yet",
                "status" => false
            ];
            return response()->json($response, 200);
        }
    }

    public function getCitiesOfProvince($shop_id, $province_id)
    {


        $areas = DB::table('cities')
            ->where('city_up', $province_id)
            ->where('shop_id', $shop_id)
            ->get();

        if(count($areas))
        {
            $response = [
                "areas" => $areas,
                "status" => true
            ];
            return response()->json($response, 200);
        } else {
            $response = [
                "msg" => "There is no areas yet",
                "status" => false
            ];
            return response()->json($response, 200);
        }
    }

    #############################################################

    public function getRegions(Request $request)
    {

        $regions = City::where('shop_id', $request->shop_id)->where('city_up', 0)->get();

        if(count($regions) > 0){
            return response()->json([
                'status' => true,
                'data' => $regions
            ]);
        }
        return response()->json([
            'status' => false,
            'msg' => 'لا توجد مناطق'
        ]);
    }

    public function getRegionCities(Request $request, $shop_id)
    {


        // $shop_id = $request->shop_id;
        $reg_id = $request->region_id;
        $cities = City::where('city_up', $reg_id)->where('shop_id' ,$shop_id)->get();


        if(count($cities) > 0){


            return response()->json([
                'status' => true,
                'data' => $cities
            ]);
        }
        return response()->json([
            'status' => false,
            'msg' => 'لا توجد مدن'
        ]);
    }
}
