<?php

namespace App\Http\Controllers;

//use Darryldecode\Cart\Cart;
use App\Model\Staticpage;
use Cart;
use Illuminate\Http\Request;

use App\Http\Requests;
use Pusher\Pusher;
use App\Ibnfarouk\Helper;
use App\Model\Activity;
use App\Model\Agent;
use App\Model\City;
use App\Model\Country;
use App\Model\Client;
use App\Model\Intro;
use App\Model\AppSetting;
use App\Model\RelatedGroup;
use Carbon\Carbon;

class TestController extends Controller
{
    //
    public function test(){
        Cart::clear();
        for ($x = 0; $x <= 10; $x++) {
            Cart::add(array(
                'id' => $x,

                'useraaaa' => 'bbbb',
                'name' => 'Sample Item',
                'price' => 67.99,
                'quantity' => 4,
                'attributes' => array( // attributes field is optional
                    'user' => 'ssss sss',
                    'email' => 'jjjjj'
                )
            ));
        }
        return Cart::getContent();

    }

    public function testPusher()
    {
        return Helper::distance(20.10000000, 10.10000000,30.99041250,31.99041250, "K");
    }

    public function countries()
    {
        $records = Country::where('status' , 1)->get();
        if(count($records))
        {

            foreach ($records as $record)
            {
                $record->flag = config('app.support_image') . $record->flag;
            }


            $response = [
                "data" => $records,
                "status" => true
            ];
            return response()->json($response, 200);
        } else {
            $response = [
                "msg" => "There is no provinces yet",
                "status" => false
            ];
            return response()->json($response, 200);
        }
    }

    public function cities(Request $request)
    {
        $record= Country::find($request->country_id);
        if ($record)
        {
            $cities = City::where('country_id', $request->country_id)->get();
            if(count($cities))
            {
                $response = [
                    "data" => $cities,
                    "status" => true
                ];
                return response()->json($response, 200);
            } else {
                $response = [
                    "msg" => "لا يوجد مدينه مسجله بهذه الدوله",
                    "status" => false
                ];
                return response()->json($response, 200);
            }
        }else {
            $response = [
                "msg" => "لا يوجد دوله مسجله",
                "status" => false
            ];
            return response()->json($response, 200);
        }
    }

    public function activites(Request $request)
    {
        $records = Activity::get();
        if(count($records))
        {
            //   foreach ($records as $record)
            // {
            //     $record->image = 'https://albadrsales.com/app-store/img/oreo.png';
            // }

            foreach ($records as $record)
            {
                $record->image = config('app.support_image') . $record->image;
            }


            $response = [
                "data" => $records,
                "status" => true
            ];
            return response()->json($response, 200);
        } else {
            $response = [
                "msg" => "لا يوجد نشاط بهذا الاسم",
                "status" => false
            ];
            return response()->json($response, 200);
        }
    }


    public function listShop(Request $request)
    {

        $records = Client::where('souq_subscribe' , 1 )
            ->where('souq_end_date','>',Carbon::today()->toDateString());

        if ($request->country) {
            $records = $records->where('country', $request->country);
        }
        if ($request->activity_id) {
            $records = $records->where('activity_id', $request->activity_id);
        }
        if ($request->city_id) {
            $records = $records->where('city_id', $request->city_id);
        }
        if ($request->name) {
            $records = $records->where('ower_name', 'like', '%' . $request->name . '%');
        }
        
         if ($request->group_id) {
        $ids = [$request->group_id];
        $related = RelatedGroup::where('group_id',$request->group_id)->pluck('client_id')->toArray();
        $groups = array_merge($related,$ids);
        $records = $records->whereIn('id',$groups);
        }
        
        
        $records = $records->paginate();

      

        if(count($records) > 0)
        {
            $response = [
                "data" => $records,
                "status" => true
            ];
            return response()->json($response, 200);
        } else {
            $response = [
                "msg" => "لا يوجد محلات بهذا الاسم",
                "status" => false
            ];
            return response()->json($response, 200);
        }
    }

    public function StaticPage(Request $request)
    {
        $record = Staticpage::get();
        if(count($record))
        {
            $response = [
                "data" => $record,
                "status" => true
            ];
            return response()->json($response, 200);
        } else {
            $response = [
                "msg" => "لا يوجد بيانات ",
                "status" => false
            ];
            return response()->json($response, 200);
        }
    }
    
    public function getIntros()
    {
        $intros = Intro::all();
        
        return (count($intros) > 0)
            ? response()->json(['status' => true,'data' => $intros])
            : response()->json(["status" => false, "message" => trans('theme.no_data_found')]);
    }
    
    public function TermsAndConditions()
    {
        $termsOfUse = AppSetting::first();

        return isset($termsOfUse)
            ? response()->json(['status' => true, 'data' => $termsOfUse->terms])
            : response()->json(["status" => false, "data" => 'Terms And Conditions Not Found']);
    }

    public function aboutUs()
    {
        $aboutUs = AppSetting::first();

        return isset($aboutUs)
            ? response()->json(['status' => true, 'data' => $aboutUs->about])
            : response()->json(["status" => false, "data" => 'About Us Not Found']);
    }

}
