<?php

/***********************/
//SouqAlbadr

Route::get('/intro', 'TestController@getIntros');
Route::get('/terms-of-use', 'TestController@TermsAndConditions');
Route::get('/about-us', 'TestController@aboutUs');

/**********************/
Route::group(['prefix' => 'api/v4/{shop_id}'], function () {
    // Users routes

        Route::post('update-player-id', 'ApiV4\ClientsController@updatePlayer');

        Route::group(['prefix' => 'souq-albadr'], function () {
            // Users routes

            Route::post('register', 'AuthController@Register');
            Route::post('login', 'AuthController@Login');
            Route::post('check-verification-code', 'AuthController@checkverificationcode');
            Route::post('forget-password', 'AuthController@forgetPassword');
            Route::post('reset-password', 'AuthController@resetPassword');
            Route::post('client-data', 'AuthController@getClientData');
            Route::post('profile', 'AuthController@Profile');
        });


    Route::get('/notifications', 'ApiV4\MainController@notifications');
    Route::post('get-my-notification', 'ApiV4\NotificationsController@getMyNotification');

    Route::get('/sliders', 'ApiV4\MainController@slider');
    Route::get('/pages', 'ApiV4\MainController@Pages');
    Route::get('/page/{id}', 'ApiV4\MainController@PageDetails');

    Route::group(['prefix' => 'users'], function () {
        Route::post('login', 'ApiV4\UsersController@authenticate');
        Route::post('get-location', 'ApiV4\UsersController@getLocation');
        Route::get('{user_id}/orders', 'ApiV4\UsersController@getUserOrders');
        Route::post('{user_id}/shortcomings', 'ApiV4\UsersController@shortcomings');
        Route::get('{user_id}/orders/{order_id}', 'ApiV4\UsersController@orderDetails');
        Route::get('{user_id}/new-orders', 'ApiV4\UsersController@getUserNewOrders');
        Route::post('{user_id}/orders/{order_id}/confirm', 'ApiV4\UsersController@confirmOrder');
        Route::post('{user_id}/search-for-client-order', 'ApiV4\UsersController@searchForClient');
        Route::post('{user_id}/stock', 'ApiV4\UsersController@userStock');
        Route::post('{user_id}/order-cancel', 'ApiV4\UsersController@orderCancel');
        Route::get('user-city/{city_id}', 'ApiV4\UsersController@getUsersOfCity');
        Route::post('switch-order', 'ApiV4\UsersController@switchOrder');
        // This route is responsible for rating the client
        Route::post('rate-client', 'ApiV4\UsersController@rateClient');
        Route::post('rate-item', 'ApiV4\CategoriesController@rateItem');
        // Users chat
        Route::post('messages', 'ApiV4\ChatController@getUserMessages');
        Route::post('get-messages', 'ApiV4\ChatController@userRequestMessages');
        Route::post('send-message', 'ApiV4\ChatController@userSendMessage');
        // Users tokens
        Route::post('register-token', 'ApiV4\ChatController@userRegisterToken');
        Route::post('remove-token', 'ApiV4\ChatController@userRemoveToken');
    });

    Route::group(['prefix' => 'clients'], function () {
        Route::post('add-to-favorites', 'ApiV4\FavoritesController@add');
        Route::post('remove-from-favorites', 'ApiV4\FavoritesController@remove');
        Route::post('get-client-favorites', 'ApiV4\FavoritesController@getClientFavorites');
        Route::post('/create', 'ApiV4\ClientsController@create');
        Route::post('login', 'ApiV4\ClientsController@authenticate');
        
        // Add To Waiting List
        Route::group(['prefix' => 'waiting-list', 'middleware' => 'auth:client'], function(){
            Route::get('/', 'ApiV4\WaitingListController@index');
            Route::post('store', 'ApiV4\WaitingListController@store');
            Route::post('delete', 'ApiV4\WaitingListController@destroy');
        });
        
        // Get client orders
        Route::post('client-orders', 'ApiV4\ClientsController@getOrders');
        // Client activation
        Route::post('active', 'ApiV4\ClientsController@activeClient');
        // Client chat
        Route::post('messages', 'ApiV4\ChatController@getClientMessages');
        Route::post('get-messages', 'ApiV4\ChatController@clientRequestMessages');
        Route::post('send-message', 'ApiV4\ChatController@clientSendMessage');
        // Client tokens
        Route::post('register-token', 'ApiV4\ChatController@clientRegisterToken');
        Route::post('remove-token', 'ApiV4\ChatController@clientRemoveToken');
        Route::post('request-code', 'ApiV4\ClientsController@requestActivationCode');
        // Client Points 
        Route::get('client-points', 'ApiV4\ClientsController@getClientPoints');
    });

    Route::get('/request-settings', 'ApiV4\MainController@requestSettings');

    // Categories
    Route::get('/cats', 'ApiV4\CategoriesController@allMainCats');
    Route::get('/cats-subs', 'ApiV4\CategoriesController@mainCatsDetails');
    Route::get('cats/{cat_id}', 'ApiV4\CategoriesController@MainCatSubs');
    Route::get('cats/{cat_id}/subcats/{sub_id}', 'ApiV4\CategoriesController@subCatItems');
    Route::get('cats-with-subcats', 'ApiV4\CategoriesController@catsWithSubCats');

    #use internal category to get data
    Route::get('cat-items/{cat_id}', 'ApiV4\CategoriesController@internalCatItems');

    // simple search
    Route::post('search', 'ApiV4\MainController@search');

    // Item details
    Route::get('items/{id}', 'ApiV4\CategoriesController@itemDetails')->name('item-details');
    Route::get('offer-items', 'ApiV4\CategoriesController@offerItems');
    Route::get('latest-items', 'ApiV4\CategoriesController@latestItems');
    Route::get('most-ordered-items', 'ApiV4\CategoriesController@mostOrderedItems');
    Route::get('abosamra-items2', 'ApiV4\CategoriesController@abosamraItems');
    Route::get('abosamra-items', 'ApiV4\CategoriesController@specialItems');
    Route::get('special-items', 'ApiV4\CategoriesController@specialItems');
    
    // Provinces
    Route::get('provinces', 'ApiV4\ProvincesController@getAllProvinces');
    Route::get('provinces/{p_id}', 'ApiV4\ProvincesController@getCitiesOfProvince');
    // Orders
    //    Route::post('orders/new', 'ApiV4\OrdersController@create');
    Route::post('orders/new', 'ApiV4\NewOrderController@saveRequest');
    Route::post('orders/request-img', 'ApiV4\NewOrderController@saveRequesImg');

    Route::post('bill/new', 'ApiV4\OrdersController@saveBillCall');

    Route::post('hang-order', 'ApiV4\OrdersController@hangOrder');

    Route::post('save-transaction', 'ApiV4\RequestController@saveFortId');

    Route::post('stand-alone', 'ApiV4\MainController@fort')->middleware('auth:client');
    Route::post('get_distance_price', 'ApiV4\NewOrderController@getDistancePrice');

    // Password resets
    /*
     Route::post('password/email', 'Auth\ForgotPasswordController@getResetToken');
     Route::post('password/reset', 'Auth\ResetPasswordController@reset');
 */

    Route::post('email-code', 'ApiV4\ClientsController@sendCode');
    Route::post('reset-password', 'ApiV4\ClientsController@resetClientPassword');

    //hatem
    Route::get('clients/profile', 'ApiV4\MainController@profileView');
    Route::post('profile', 'ApiV4\MainController@profileSave');
    Route::get('user-profile', 'ApiV4\MainController@userProfileView');
    Route::post('user-profile', 'ApiV4\MainController@userProfileSave');
    Route::get('user-stock', 'ApiV4\MainController@userStock');
    Route::get('short-comings', 'ApiV4\MainController@shortcomings');

    Route::get('requests', 'ApiV4\RequestController@requests');
    Route::post('request-start-move', 'ApiV4\RequestController@startMove');
    Route::get('edit-order/{request_id}', 'ApiV4\RequestController@editOrder');
    
    Route::get('request-details/{request_id}', 'ApiV4\RequestController@requestDetails');
    Route::post('request-cancel', 'ApiV4\RequestController@requestCancel');
    Route::post('request-rate', 'ApiV4\RequestController@requestRate');
    Route::post('request-details-rate', 'ApiV4\RequestController@requestDetailsRate');
    Route::get('about-us', 'ApiV4\MainController@aboutUs');
    Route::get('terms-of-use', 'ApiV4\MainController@termsOfUse');
    Route::get('contact-us', 'ApiV4\MainController@contactUs');
    Route::post('contact-us', 'ApiV4\MainController@postContactUs');
    Route::get('privacy-policy', 'ApiV2\MainController@privacyPolicy');


    Route::get('item-colors', 'ApiV4\MainController@getItemsColors');
    Route::get('item-sizes', 'ApiV4\MainController@getItemsSizes');

    Route::get('get-regions', 'ApiV4\ProvincesController@getRegions');
    Route::get('get-region-cities', 'ApiV4\ProvincesController@getRegionCities');

    Route::get('chat', function ($id) {
        return response()->json([
            'status' => true,
            //            'url' => urldecode('https://tawk.to/chat/5eb7b0d3967ae56c52186410/default/?$_tawk_popout=true')
            'url' => url('api/v1/' . $id . '/call')

        ]);
    });

    Route::get('client-data', function ($id, Request $request) {

        $settings = \App\RequestSettings::where('shop_id', $id)->first();

        $client = auth()->guard('client')->user();
        if ($client) {
            $regions = \DB::table('regions')->selectRaw('id, name_ar, name_en')->get();
            $city = \DB::table('charge_cities')->find($client->city_id);
            $region_id = 0;
            $cities = \DB::table('charge_cities')->where('region_id', $regions[0]->id)->selectRaw('id, name_ar, name_en')->get();

            if ($city) {
                $region_id = $city->region_id;
                $cities = \DB::table('charge_cities')->where('region_id', $region_id)->selectRaw('id, name_ar, name_en')->get();
            }


            return response()->json([
                'status' => true,
                'tele' => $client->tele,
                'city_id' => $client->city_id,
                'region_id' => $region_id,
                'regions' => $regions,
                'cities' => $cities,
                'lon' => '21.21212',
                'lat' => '39.18945880',
                'epay' => (bool) $settings->epay ?? true,
                'delivery' => (bool) $settings->delivery ?? false,
                'bank' => (bool) $settings->bank ?? true,
            ]);
        } else {
            return response()->json([
                'status' => false,
                'msg' => 'no user'
            ]);
        }
    });


    Route::post('check-coupon', 'ApiV4\NewOrderController@checkCoupon');
    Route::get('delete-account', 'ApiV4\ClientsController@deleteAccount');


    Route::get('call', function () {
        return view('api/chat');
    });
});




?>