<?php


Route::get('m', function(){
   
    $mail = request('mail');
    \Mail::raw('hello ' . rand() , function($message) use($mail){
        $message->to($mail)->subject('test mail me: ' . rand() );
        
    });
    
    return 'done';
});


Route::group(['prefix' => 'api/v5/{shop_id}'], function () {
    // Users routes

    Route::get('/notifications', 'ApiV5\MainController@notifications');
    Route::post('get-my-notification', 'ApiV5\NotificationsController@getMyNotification');

    Route::get('/sliders', 'ApiV5\MainController@slider');
    Route::get('/pages', 'ApiV5\MainController@Pages');
    Route::get('/page/{id}', 'ApiV5\MainController@PageDetails');

    Route::group(['prefix' => 'users'], function () {
        Route::post('login', 'ApiV5\UsersController@authenticate');
        Route::post('get-location', 'ApiV5\UsersController@getLocation');
        Route::get('{user_id}/orders', 'ApiV5\UsersController@getUserOrders');
        Route::post('{user_id}/shortcomings', 'ApiV5\UsersController@shortcomings');
        Route::get('{user_id}/orders/{order_id}', 'ApiV5\UsersController@orderDetails');
        Route::get('{user_id}/new-orders', 'ApiV5\UsersController@getUserNewOrders');
        Route::post('{user_id}/orders/{order_id}/confirm', 'ApiV5\UsersController@confirmOrder');
        Route::post('{user_id}/search-for-client-order', 'ApiV5\UsersController@searchForClient');
        Route::post('{user_id}/stock', 'ApiV5\UsersController@userStock');
        Route::post('{user_id}/order-cancel', 'ApiV5\UsersController@orderCancel');
        Route::get('user-city/{city_id}', 'ApiV5\UsersController@getUsersOfCity');
        Route::post('switch-order', 'ApiV5\UsersController@switchOrder');
        // This route is responsible for rating the client
        Route::post('rate-client', 'ApiV5\UsersController@rateClient');
        Route::post('rate-item', 'ApiV5\CategoriesController@rateItem');
        // Users chat
        Route::post('messages', 'ApiV5\ChatController@getUserMessages');
        Route::post('get-messages', 'ApiV5\ChatController@userRequestMessages');
        Route::post('send-message', 'ApiV5\ChatController@userSendMessage');
        // Users tokens
        Route::post('register-token', 'ApiV5\ChatController@userRegisterToken');
        Route::post('remove-token', 'ApiV5\ChatController@userRemoveToken');
    });

    Route::group(['prefix' => 'clients'], function () {
        Route::post('add-to-favorites', 'ApiV5\FavoritesController@add');
        Route::post('remove-from-favorites', 'ApiV5\FavoritesController@remove');
        Route::post('get-client-favorites', 'ApiV5\FavoritesController@getClientFavorites');
        Route::post('/create', 'ApiV5\ClientsController@create');
        Route::post('login', 'ApiV5\ClientsController@authenticate');
        Route::delete('remove-account', 'ApiV5\ClientsController@removeAccount');
        // Get client orders
        Route::post('client-orders', 'ApiV5\ClientsController@getOrders');
        // Client activation
        Route::post('active', 'ApiV5\ClientsController@activeClient');
        // Client chat
        Route::post('messages', 'ApiV5\ChatController@getClientMessages');
        Route::post('get-messages', 'ApiV5\ChatController@clientRequestMessages');
        Route::post('send-message', 'ApiV5\ChatController@clientSendMessage');
        // Client tokens
        Route::post('register-token', 'ApiV5\ChatController@clientRegisterToken');
        Route::post('remove-token', 'ApiV5\ChatController@clientRemoveToken');
        Route::post('request-code', 'ApiV5\ClientsController@requestActivationCode');
    });

    Route::get('/request-settings', 'ApiV5\MainController@requestSettings');

    // Categories
    Route::get('/cats', 'ApiV5\CategoriesController@allMainCats');
    Route::get('/cats-subs', 'ApiV5\CategoriesController@mainCatsDetails');
    Route::get('cats/{cat_id}', 'ApiV5\CategoriesController@MainCatSubs');
    Route::get('cats/{cat_id}/subcats/{sub_id}', 'ApiV5\CategoriesController@subCatItems');

    #use internal category to get data
    Route::get('cat-items/{cat_id}', 'ApiV5\CategoriesController@internalCatItems');

    // simple search
    Route::post('search', 'ApiV5\MainController@search');

    // Item details
    Route::get('items/{id}', 'ApiV5\CategoriesController@itemDetails')->name('item-details');
    Route::get('offer-items', 'ApiV5\CategoriesController@offerItems');
    Route::get('latest-items', 'ApiV5\CategoriesController@latestItems');
    Route::get('most-ordered-items', 'ApiV5\CategoriesController@mostOrderedItems');
    // Provinces
    Route::get('provinces', 'ApiV5\ProvincesController@getAllProvinces');
    Route::get('provinces/{p_id}', 'ApiV5\ProvincesController@getCitiesOfProvince');
    // Orders
    //    Route::post('orders/new', 'ApiV5\OrdersController@create');
    Route::post('orders/new', 'ApiV5\NewOrderController@saveRequest');
    Route::post('orders/request-img', 'ApiV5\NewOrderController@saveRequesImg');

    Route::post('bill/new', 'ApiV5\OrdersController@saveBillCall');

    Route::post('hang-order', 'ApiV5\OrdersController@hangOrder');

    Route::post('save-transaction', 'ApiV5\RequestController@saveFortId');

    Route::post('stand-alone', 'ApiV5\MainController@fort')->middleware('auth:client');
    Route::post('get_distance_price', 'ApiV5\NewOrderController@getDistancePrice');

    // Password resets
    /*
     Route::post('password/email', 'Auth\ForgotPasswordController@getResetToken');
     Route::post('password/reset', 'Auth\ResetPasswordController@reset');
 */

    Route::post('email-code', 'ApiV5\ClientsController@sendCode');
    Route::post('reset-password', 'ApiV5\ClientsController@resetClientPassword');

    //hatem
    Route::get('clients/profile', 'ApiV5\MainController@profileView');
    Route::post('profile', 'ApiV5\MainController@profileSave');
    Route::get('user-profile', 'ApiV5\MainController@userProfileView');
    Route::post('user-profile', 'ApiV5\MainController@userProfileSave');
    Route::get('user-stock', 'ApiV5\MainController@userStock');
    Route::get('short-comings', 'ApiV5\MainController@shortcomings');

    Route::get('requests', 'ApiV5\RequestController@requests');
    Route::post('request-start-move', 'ApiV5\RequestController@startMove');
    Route::get('request-details/{request_id}', 'ApiV5\RequestController@requestDetails');
    Route::get('edit-order/{request_id}', 'ApiV5\RequestController@editOrder');

    Route::post('request-cancel', 'ApiV5\RequestController@requestCancel');
    Route::post('request-rate', 'ApiV5\RequestController@requestRate');
    Route::post('request-details-rate', 'ApiV5\RequestController@requestDetailsRate');
    Route::get('about-us', 'ApiV5\MainController@aboutUs');
    Route::get('terms-of-use', 'ApiV5\MainController@termsOfUse');
    Route::get('contact-us', 'ApiV5\MainController@contactUs');
    Route::post('contact-us', 'ApiV5\MainController@postContactUs');


    Route::get('item-colors', 'ApiV5\MainController@getItemsColors');
    Route::get('item-sizes', 'ApiV5\MainController@getItemsSizes');

    Route::get('get-regions', 'ApiV5\ProvincesController@getRegions');
    Route::get('get-region-cities', 'ApiV5\ProvincesController@getRegionCities');

    Route::get('chat', function ($id) {
        return response()->json([
            'status' => true,
            //            'url' => urldecode('https://tawk.to/chat/5eb7b0d3967ae56c52186410/default/?$_tawk_popout=true')
            'url' => url('api/v1/' . $id . '/call')

        ]);
    });

    Route::get('client-data', function ($id, Request $request) {

        $settings = \App\RequestSettings::where('shop_id', $id)->first();

        $client = auth()->guard('client')->user();
        if ($client) {
            $regions = \DB::table('regions')->selectRaw('id, name_ar, name_en')->get();
            $city = \DB::table('charge_cities')->find($client->city_id);
            $region_id = 0;
            $cities = \DB::table('charge_cities')->where('region_id', $regions[0]->id ?? 0)->selectRaw('id, name_ar, name_en')->get();

            if ($city) {
                $region_id = $city->region_id;
                $cities = \DB::table('charge_cities')->where('region_id', $region_id)->selectRaw('id, name_ar, name_en')->get();
            }


            return response()->json([
                'status' => true,
                'tele' => $client->tele,
                'city_id' => $client->city_id,
                'region_id' => $region_id,
                'regions' => $regions,
                'cities' => $cities,
                'lon' => '21.21212',
                'lat' => '39.18945880',
                'epay' => (bool) $settings->epay ?? true,
                'delivery' => (bool) $settings->delivery ?? false,
                'bank' => (bool) $settings->bank ?? true,
            ]);
        } else {
            return response()->json([
                'status' => false,
                'msg' => 'no user'
            ]);
        }
    });


    Route::post('check-coupon', 'ApiV5\NewOrderController@checkCoupon');


    Route::get('call', function () {
        return view('api/chat');
    });
});




?>