<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use App\RequestSettings;
class ItemType extends Model
{
    protected $table   = 'items_type';
    protected $guarded = [];
    protected $appends = ['limited_items', 'image', 'url'];

    public function newQuery()
    {
        return parent::newQuery()->wherePublished(1);
    }
    
    public function items()
    {
        return $this->hasMany('App\Item', 'sale_unit');
    }

    public function subcategory()
    {
        return $this->hasMany(ItemType::class, 'category_id');
    }

    public function getLimitedItemsAttribute($value)
    {
       
       
              return $this->items()->where('online', 1)->where('quantity','>',0)->take(4)->get();
        
       
    }
    
    public function getImageAttribute()
    {
        return (in_array($this->upload_img, ['', ' ', null]))
            ? config('app.img_url') . 'logo.png'
            : config('app.img_url') . $this->upload_img;
    }

    public function getUrlAttribute()
    {
        $api_version = request()->segment(2);
        return $this->category_id == 0
            ? "api/$api_version/cats/$this->id"
            : "api/$api_version/cats/$this->category_id/subcats/$this->id";
    }
}
